package Client;

import Client.ClientSocket;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;

public class Client {
    
    // Private members
    private ClientSocket socket;
    private String error = " ";
    private boolean turning = false;
    private boolean direction = false;
    private int pitch = 0;
    private boolean is_running = false;
    private boolean is_up = false;    
    private Timer timer;
    
    // Public members
    public  int[] param = {0, 0, 0, 0, 0};
    public String msg = " ";
    public boolean is_connected = false; 
    
    // Public Methods
    public Client() {
        socket = new ClientSocket();
        
        timer = new Timer(50, new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if(direction)
                    pitch++;                
                else
                    pitch --;
                
                if(pitch < 0)
                    pitch = 360;
                
                if(pitch > 360)
                    pitch = 0;
                
                System.out.println(pitch);
                
                param[0] = 0;           // creature ID
                param[1] = 0;           // VL
                param[2] = 0;           // VR
                param[3] = pitch;       // angle in degrees
                socket.SendCommand("setangle", param, 4);  // Start                
            }
        });
        
    }
    
    public boolean Connect(String _host, int port) {
        
        socket.SetHost(_host);
        socket.SetPort(port);
        
        if(!socket.Connect()) {
            error = socket.getError();
            System.err.println("Error");
            return false;
        }
        is_connected = true;
        return true;
    }
    
    public void Disconnect() {
        socket.SendCommand("quit");
        socket.Disconnect();
    }
    
    public boolean Start_caracter() {

        param[0] = 0;
        param[1] = 0;
        param[2] = 0;
        param[3] = 0;
        param[4] = 0;
        
        if(!socket.SendCommand("startgame")){
            error = socket.getError();
            return false;
        }
        
        if(!socket.SendCommand("new", param, 3)){
            error = socket.getError();
            return false;
        }            
        
        param[0] = 0;
        if(!socket.SendCommand("camera", param, 1)){
            error = socket.getError();
            return false;
        }            
        
        if(!socket.SendCommand("start", param, 1)){
            error = socket.getError();
            return false;
        }
        return true;
    }
    
    public void on_up_press() {
        
        if(is_running){
            if(!is_up){
                param[0] = 0;           // creature ID
                param[1] = 0;           // VL
                param[2] = 0;           // VR
                param[3] = pitch;       // angle in degrees
                socket.SendCommand("setangle", param, 4);  // Stop
                is_running = false;                
            }                
        }
        else {
            param[0] = 0;           // creature ID
            param[1] = 1;           // VL
            param[2] = 1;           // VR
            param[3] = pitch;       // angle in degrees
            socket.SendCommand("setangle", param, 4);  // Start

            is_running = true;
            is_up = true;
        }        
    }
    
    public void on_down_press() {
        
        if(is_running){
            param[0] = 0;          // creature ID
            param[1] = 0;          // VL
            param[2] = 0;          // VR
            param[3] = pitch;     // angle
            socket.SendCommand("setangle", param, 4);  // Stop 
            is_running = false;
        }         
    }
    
    
     public void on_left_press() {
         
         if(turning) {
             if(direction) {
                param[0] = 0;           // creature ID
                param[1] = 0;           // VL
                param[2] = 0;           // VR
                param[3] = pitch;       // angle in degrees
                socket.SendCommand("setangle", param, 4);  // Parar

                turning = false;                
                timer.stop();
             }
         }
         else {
             turning = true;
             direction = false;
             timer.start();
         }         
     }
     
     public void on_right_press() {
         
         if(turning) {
             if(!direction) {
                param[0] = 0;           // creature ID
                param[1] = 0;           // VL
                param[2] = 0;           // VR
                param[3] = pitch;       // angle in degrees
                socket.SendCommand("setangle", param, 4);  // Parar

                turning = false;                
                timer.stop();
             }
         }
         else {
             turning = true;
             direction = true;
             timer.start();
         }         
     }
    
    public String getError(){
        return error;
    }
            
}
